#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Icons\flyff.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
Opt("GuiOnEventMode",1)
Opt("TrayMenuMode",1)
Opt("TrayOnEventMode",1)




;~  General Declarations

Global $title = "FTool Extended 0.9a", $ar_setting[50][2]
Global $cmb_skill = "1|2|3|4|5|6|7|8", $cmb_key = "1|2|3|4|5|6|7|8|9"
Global $sel_pntr
Global $dbluse

;~  Feed
Global $feed_arwin[4], $feed_winpid[4]
Global $feed_wintitle[4], $feed_skill[4], $feed_key[4], $feed_inpt[4], $feed_selwin[4], $feed_start[4], $feed_stop[4]

;~  Spam

Global $spam_arwin[4], $spam_winpid[4]
Global $spam_wintitle[4], $spam_skill[4], $spam_key[4], $spam_inpt[4], $spam_selwin[4], $spam_start[4], $spam_stop[4]

;~  Collect

Global $coll_arwin[4], $coll_winpid[4]
Global $coll_key[4], $coll_selwin[4], $coll_start[4], $coll_stop[4], $coll_wintitle[4]

;~  Buff

Global $buff_arwin[2], $buff_winpid[2]
Global $buff_wintitle[2], $buff_skills[2][12], $buff_selopt[2][4], $buff_inpt[2][4], $buff_selwin[2], $buff_start[2], $buff_stop[2]

;~  Buff Options

Global $buffopt_skill[2][16], $buffopt_key[2][16], $buff_name[16]


$buff_name[0] = "Heal"
$buff_name[1] = "Heal Rain"
$buff_name[2] = "Spiriture Fortune"
$buff_name[3] = "Geburah Tiprheth"
$buff_name[4] = "Mental Sign"
$buff_name[5] = "Heap Up"
$buff_name[6] = "Beef Up"
$buff_name[7] = "Haste"
$buff_name[8] = "Quick Step"
$buff_name[9] = "Cannonball"
$buff_name[10] = "Cats Reflex"
$buff_name[11] = "Accuracy"
$buff_name[12] = "Patience"
$buff_name[13] = "Protection"
$buff_name[14] = "Holy Guard"
$buff_name[15] = "Prevention"

;~  Window Settings

Global $winopt_arlist[1][2], $winopt_int, $winopt_aref = 0, $winopt_clist[1][2], $winopt_ctime[1][4], $winopt_ctoken = 0, $winopt_cinit[1]

;~  Window

Global $win_gui, $win_list
Global $win_hwnd, $win_arlist[1][2], $win_client[4][4][2]


#Region Gui Initialize

$main = GUICreate($title,448,463,@DesktopWidth / 2 - 250,@DesktopHeight / 2 - 250)
GUISetOnEvent(-3,"_Exit")

$tray = TrayCreateItem("Exit")
TrayItemSetOnEvent($tray,"_Exit")

GUICtrlCreateTab(0,0,450,465)
#Region Feeder
GUICtrlCreateTabItem("Feeder")
GUICtrlCreateGroup("FIRST Auto Feeder",10,23,430,100)
GUICtrlCreateGroup("SECOND Auto Feeder",10,133,430,100)
GUICtrlCreateGroup("THIRD Auto Feeder",10,243,430,100)
GUICtrlCreateGroup("FOURTH Auto Feeder",10,353,430,100)



For $i = 0 To 3

	GUICtrlCreateLabel("Select Skill Bar",20,40 + ($i * 110),90,13)
	GUICtrlCreateLabel("Select F-Key",20,80 + ($i * 110),70,13)
	GUICtrlCreateLabel("Select Feed Interval" & @CRLF & "(in seconds)",130,40 + ($i * 110),100,30)
	$feed_wintitle[$i] = GUICtrlCreateLabel("No Window Selected",240,75 + ($i * 110),110,30)

	$feed_skill[$i] = GUICtrlCreateCombo("Skill Bar",20,55 + ($i * 110),80,25,0x3)
	$feed_key[$i] = GUICtrlCreateCombo("F-Key",20,95 + ($i * 110),80,25,0x3)
	$feed_inpt[$i] = GUICtrlCreateInput("30",130,75 + ($i * 110),70,20,0x2000)
	$feed_selwin[$i] = GUICtrlCreateButton("Select Window",240,40 + ($i * 110),85,20)
	$feed_start[$i] = GUICtrlCreateButton("Start",350,40 + ($i * 110),70,20)
	$feed_stop[$i] = GUICtrlCreateButton("Stop",350,75 + ($i * 110),70,20)

	GUICtrlSetData($feed_skill[$i],$cmb_skill)
	GUICtrlSetData($feed_key[$i],$cmb_key)
	GUICtrlSetState($feed_stop[$i],128)
	GUICtrlSetOnEvent($feed_start[$i],"_FeedPos" & $i + 1)
	GUICtrlSetOnEvent($feed_stop[$i],"_SFeedPos" & $i + 1)
	GUICtrlSetOnEvent($feed_selwin[$i],"_FeedWin" & $i + 1)
Next

#EndRegion

#Region Spammer
GUICtrlCreateTabItem("Spammer")
GUICtrlCreateGroup("FIRST Auto Spammer",10,23,430,100)
GUICtrlCreateGroup("SECOND Auto Spammer",10,133,430,100)
GUICtrlCreateGroup("THIRD Auto Spammer",10,243,430,100)
GUICtrlCreateGroup("FOURTH Auto Spammer",10,353,430,100)

For $i = 0 To 3
	GUICtrlCreateLabel("Select Skill Bar",20,40 + ($i * 110),90,13)
	GUICtrlCreateLabel("Select F-Key",20,80 + ($i * 110),70,13)
	GUICtrlCreateLabel("Select Spam Interval" & @CRLF & "(in seconds)",130,40 + ($i * 110),100,30)
	$spam_wintitle[$i] = GUICtrlCreateLabel("No Window Selected",240,75 + ($i * 110),110,30)

	$spam_skill[$i] = GUICtrlCreateCombo("Skill Bar",20,55 + ($i * 110),80,25,0x3)
	$spam_key[$i] = GUICtrlCreateCombo("F-Key",20,95 + ($i * 110),80,25,0x3)
	$spam_inpt[$i] = GUICtrlCreateInput("5",130,75 + ($i * 110),70,20,0x2000)
	$spam_selwin[$i] = GUICtrlCreateButton("Select Window",240,40 + ($i * 110),85,20)
	$spam_start[$i] = GUICtrlCreateButton("Start",350,40 + ($i * 110),70,20)
	$spam_stop[$i] = GUICtrlCreateButton("Stop",350,75 + ($i * 110),70,20)

	GUICtrlSetData($spam_skill[$i],$cmb_skill)
	GUICtrlSetData($spam_key[$i],$cmb_key)
	GUICtrlSetState($spam_stop[$i],128)
	GUICtrlSetOnEvent($spam_start[$i],"_SpamPos" & $i + 1)
	GUICtrlSetOnEvent($spam_stop[$i],"_SSpamPos" & $i + 1)
	GUICtrlSetOnEvent($spam_selwin[$i],"_SpamWin" & $i + 1)
Next

#EndRegion

#Region Collector
GUICtrlCreateTabItem("Collector")
GUICtrlCreateGroup("FIRST Collector",10,23,430,100)
GUICtrlCreateGroup("SECOND Collector",10,133,430,100)
GUICtrlCreateGroup("THIRD Collector",10,243,430,100)
GUICtrlCreateGroup("FOURTH Collector",10,353,430,100)

For $i = 0 To 3
	GUICtrlCreateLabel("Select F-Key For Battery",20,50 + ($i *	110),160,13)
	$coll_wintitle[$i] = GUICtrlCreateLabel("No Window Selected",220,95 + ($i * 110),110,30)
	
	$coll_key[$i] = GUICtrlCreateCombo("F-Key",35,70 + ($i * 110), 80,25,0x3)
	$coll_selwin[$i] = GUICtrlCreateButton("Select Window",220,70 + ($i * 110),85,20)
	$coll_start[$i] = GUICtrlCreateButton("Start",350,50 + ($i * 110),70,20)
	$coll_stop[$i] = GUICtrlCreateButton("Stop",350,85 + ($i * 110), 70,20)
	
	GUICtrlSetData($coll_key[$i],$cmb_key)
	GUICtrlSetState($coll_stop[$i],128)	
	GUICtrlSetOnEvent($coll_selwin[$i],"_CollWin" & $i + 1)
	GUICtrlSetOnEvent($coll_start[$i],"_CollPos" & $i + 1)
	GUICtrlSetOnEvent($coll_stop[$i],"_SCollPos" & $i + 1)
Next


#EndRegion

#Region Buffer

GUICtrlCreateTabItem("Buffer")
GUICtrlCreateGroup("FIRST Buffer",10,23,430,212)
GUICtrlCreateGroup("SECOND Buffer",10,243,430,212)
GUICtrlCreateGroup("Options",250,40,180,140)
GUICtrlCreateGroup("Options",250,260,180,140)

For $i = 0 To 1
	
 	GUICtrlCreateLabel("Set Interval",360,50 + ($i * 220),70,20)
	$buff_wintitle[$i] = GUICtrlCreateLabel("No Window Selected",250,208 + ($i * 220),110,30)
	


	For $a = 4 To 9
		$buff_skills[$i][$a - 4] = GUICtrlCreateCheckbox($buff_name[$a],30,50  + ($i * 220) + (($a - 4) * 30),90,20)
	Next
	For $a = 10 To 15
		$buff_skills[$i][$a - 4] = GUICtrlCreateCheckbox($buff_name[$a],150,50  + ($i * 220) + (($a - 10) * 30),90,20)
	Next



	$buff_selopt[$i][0] = GUICtrlCreateCheckbox("Use Heal",255,70 + ($i * 220),80,20)
	$buff_selopt[$i][1] = GUICtrlCreateCheckbox("Use Heal Rain",255,95 + ($i * 220),90,20)
	$buff_selopt[$i][2] = GUICtrlCreateCheckbox("Use SF And GT",255,120 + ($i * 220),90,20)
	$buff_selopt[$i][3] = GUICtrlCreateCheckbox("Use Buffs",255,145 + ($i * 220),80,20)
	
	$buff_inpt[$i][0] = GUICtrlCreateInput("1",360,70 + ($i * 220),50,18,0x2000)
	$buff_inpt[$i][1] = GUICtrlCreateInput("3",360,95 + ($i * 220),50,18,0x2000)
	$buff_inpt[$i][2] = GUICtrlCreateInput("50",360,120 + ($i * 220),50,18,0x2000)
	$buff_inpt[$i][3] = GUICtrlCreateInput("500",360,145 + ($i * 220),50,18,0x2000)
	
	$buff_selwin[$i] = GUICtrlCreateButton("Select Window",250,185 + ($i * 220),85,20)
	$buff_start[$i] = GUICtrlCreateButton("Start",370,185 + ($i * 220),60,20)
	$buff_stop[$i] = GUICtrlCreateButton("Stop",370,208 + ($i * 220),60,20)
	
	
		GUICtrlSetState($buff_stop[$i],128)
		GUICtrlSetOnEvent($buff_selopt[$i][0],"_BuffHeal" & $i + 1)
		GUICtrlSetOnEvent($buff_selopt[$i][1],"_BuffHealRain" & $i + 1)
		GUICtrlSetOnEvent($buff_selwin[$i],"_BuffWin" & $i + 1)
		GUICtrlSetOnEvent($buff_start[$i],"_BuffPos" & $i + 1)
		GUICtrlSetOnEvent($buff_stop[$i],"_SBuffPos" & $i + 1)
		
		
Next



#EndRegion

#Region Buff Options
GUICtrlCreateTabItem("Buff Options")
GUICtrlCreateGroup("FIRST Buff Window",10,23,215,430)
GUICtrlCreateGroup("SECOND Buff Window",230,23,215,430)

For $i = 0 To 1

	For $a = 0 To 15
		GUICtrlCreateLabel($buff_name[$a],20 + ($i * 220),50 + ($a * 25),85,20)		
		$buffopt_skill[$i][$a] = GUICtrlCreateCombo("Skill Bar",108 + ($i * 220),48 + ($a * 25),63,20,0x3)
		$buffopt_key[$i][$a] = GUICtrlCreateCombo("F-Key",170 + ($i * 220),48 + ($a * 25),52,10,0x3)

		GUICtrlSetData($buffopt_skill[$i][$a],$cmb_skill)
		GUICtrlSetData($buffopt_key[$i][$a],$cmb_key)
	Next
	
Next



#EndRegion

#region Skill Macros
GUICtrlCreateTabItem("Skill Macros")
#EndRegion

#Region Window Settings
GUICtrlCreateTabItem(" Window Settings")
GUICtrlCreateGroup("Settings",10,23,430,430)

$winopt_list = GUICtrlCreateList("",40,90,170,150)
$winopt_refresh = GUICtrlCreateButton("Refresh",260,110,70,20)
$winopt_rename = GUICtrlCreateButton("Rename",340,110,70,20)
$winopt_hide = GUICtrlCreateButton("Hide",260,145,70,20)
$winopt_show = GUICtrlCreateButton("Show",340,145,70,20)
$winopt_kill = GUICtrlCreateButton("Kill",260,180,70,20)
$winopt_jump = GUICtrlCreateButton("Jump To",340,180,70,20)
$winopt_closetime = GUICtrlCreateButton("Close On Time",295,215,80,20)
$winopt_ctlist = GUICtrlCreateList("",40,270,170,150)
GUICtrlCreateLabel("Next Window To Close:",230,280,130,20)
$winopt_cwindis = GUICtrlCreateLabel("",230,300,130,20)
GUICtrlCreateLabel("Time Left:",230,340,50,20)
$winopt_cwintimer = GUICtrlCreateLabel("00:00:00",310,340,70,20)
$winopt_ctstop = GUICtrlCreateButton("Remove",260,390,70,20)


GUICtrlSetOnEvent($winopt_refresh,"_WinOptRefresh")
GUICtrlSetOnEvent($winopt_rename,"_Rename")
GUICtrlSetOnEvent($winopt_hide,"_Hide")
GUICtrlSetOnEvent($winopt_show,"_Show")
GUICtrlSetOnEvent($winopt_kill,"_Kill")
GUICtrlSetOnEvent($winopt_jump,"_JumpTo")
GUICtrlSetOnEvent($winopt_closetime,"_WinOptCTime")
GUICtrlSetOnEvent($winopt_ctstop,"_Remove")

#EndRegion



GUISetState(@SW_SHOW,$main)
Global $gui_pid = WinGetProcess($main)

#EndRegion


#Region Function Include
#include "Include\writeini.au3"
#include "Include\feedspam.au3"
#include "Include\collect.au3"
#include "Include\buff.au3"
#include "Include\regular.au3"
#include "Include\window.au3"
#EndRegion Function Include

_IniLoad()

$val = IniRead("config.ini","Global","allowdbluse","x")
If $val = "x" Then
Else
	If Number($val) =  0 Or Number($val) = 1 Then
		$dbluse = Number($val)
	EndIf
EndIf

$val = IniRead("config.ini","Global","autorefresh","x")
If $val = "x" Then
Else
	If Number($val) =  0 Or Number($val) = 1 Then
		$winopt_aref = Number($val)
	EndIf
EndIf

$winopt_init_aref = TimerInit()
$winopt_init_cdist = TimerInit()

While 1
	
	For $i = 0 To 3
		If WinExists($feed_arwin[$i]) = 0 Then
			$sel_pntr = $i
			_FeedSpamStop()
		EndIf
		
		If WinExists($spam_arwin[$i]) = 0 Then
			$sel_pntr = $i + 10
			_FeedSpamStop()
		EndIf
		If $i > 1 Then
			Else
			If WinExists($buff_arwin[$i]) = 0 Then
				$sel_pntr = $i
				_BuffStop()
			EndIf
		EndIf
		If WinExists($coll_arwin[$i]) = 0 Then
			$sel_pntr = $i + 30
			_CollStop()
		EndIf
		
	Next
	
	
	For $i = 0 To 3

		If (Not $feed_arwin[$i] = "" And ProcessExists($feed_winpid[$i]) = 0) Or (Not $feed_arwin[$i] = "" And WinExists($feed_arwin[$i] = 0)) Then
			$sel_pntr = $i
			_FeedSpamStop()
		ElseIf (Not $spam_arwin[$i] = "" And ProcessExists($spam_winpid[$i]) = 0) Then
			$sel_pntr = $i + 10
			_FeedSpamStop()	
		EndIf
	Next
	For $i = 0 To 1
		If Not $buff_arwin[$i] = "" And ProcessExists($buff_winpid[$i]) = 0 Then
			$sel_pntr = $i
			_BuffStop()
		EndIf
	Next
	If $winopt_aref = 1 And TimerDiff($winopt_init_aref) >= 5000 Then
		$winopt_init_aref = TimerInit()
		_WinOptRefresh()
	EndIf	
	
	If Not $winopt_clist[$winopt_ctoken][1] = "" And TimerDiff($winopt_init_cdist) > 200 Then
		$winopt_init_cdist = TimerInit()
		Local $hour = 0, $min = 0, $sec = 0
		_TicksToTime($winopt_ctime[$winopt_ctoken][0] - TimerDiff($winopt_cinit[$winopt_ctoken]),$hour,$min,$sec)

		GUICtrlSetData($winopt_cwintimer,StringFormat("%02i:%02i:%02i", $hour,$min,$sec))
		
	EndIf
		
	If Not $winopt_clist[$winopt_ctoken][1] = "" Then
		If $winopt_ctime[$winopt_ctoken][0] - TimerDiff($winopt_cinit[$winopt_ctoken]) <= 0 Then
			WinKill($winopt_clist[$winopt_ctoken][1])
			_WinOptCTRemove($winopt_ctoken)
		EndIf
	EndIf
	
	
	Sleep(50)
WEnd
