



Func _SelWindow()
	GUISetState(@SW_DISABLE,$main)	
	$win_gui = GUICreate("Select A FlyFF Client",250,200,@DesktopWidth / 2 - 100,@DesktopHeight / 2 - 100)
	$win_list = GUICtrlCreateList("",10,10,150,180)
	$win_select = GUICtrlCreateButton("Select Client",170,30,70,20)
	$win_jump = GUICtrlCreateButton("Jump To",170,70,70,20)
	$win_refr = GUICtrlCreateButton("Refresh",170,110,70,20)
	$win_back = GUICtrlCreateButton("Back",170,150,70,20)
	GUISetOnEvent(-3,"_SelWinBack",$win_gui)
	GUICtrlSetOnEvent($win_back,"_SelWinBack")
	GUICtrlSetOnEvent($win_refr,"_SelWinRefresh")
	GUICtrlSetOnEvent($win_jump,"_SelWinJump")
	GUICtrlSetOnEvent($win_select,"_SelWinSelect")
	_SelWinRefresh()

	
	GUISetState(@SW_SHOW,$win_gui)

	
EndFunc

Func _SelWinRefresh()
	Dim $win_arlist[1][2]
	GUICtrlSetData($win_list,"")
	$prolist = ProcessList("data.dll")
	$winlist = WinList()
	
	For $i = 1 To $winlist[0][0]
		If WinGetProcess($winlist[$i][0]) = 0 Then
			Local $int = UBound($win_arlist)
			$win_arlist[$int - 1][0] = $winlist[$i][0]
			$win_arlist[$int - 1][1] = $winlist[$i][1]
			ReDim $win_arlist[$int + 1][2]		
			GUICtrlSetData($win_list,$winlist[$i][0] & "  --  " & $winlist[$i][1])
		EndIf
		For $a = 1 To $prolist[0][0]
			If WinGetProcess($winlist[$i][0]) = $prolist[$a][1] Then
				Local $int = UBound($win_arlist)				
				$win_arlist[$int - 1][0] = $winlist[$i][0]
				$win_arlist[$int - 1][1] = $winlist[$i][1]
				ReDim $win_arlist[$int + 1][2]		
				GUICtrlSetData($win_list,$winlist[$i][0] & "  --  " & $winlist[$i][1])				
			EndIf
			
		Next
		
	Next
	

	
EndFunc

Func _SelWinBack()
	GUISetState(@SW_ENABLE,$main)
	GUISetState(@SW_RESTORE,$main)
	GUIDelete($win_gui)
EndFunc

Func _SelWinJump()
	Local $winselect = GUICtrlRead($win_list)
	For $i = 0 To UBound($win_arlist) - 1
		If $winselect = ($win_arlist[$i][0] & "  --  " & $win_arlist[$i][1]) Then
			If WinExists($win_arlist[$i][1]) Then
				WinActivate($win_arlist[$i][1])
			Else
				_MsgBox(0,$title,"The selected client doesn't exist!" & @CRLF & "You should refresh the list.",$win_gui)
			EndIf
		EndIf		
	Next
EndFunc

Func _SelWinSelect()
	If $sel_pntr >= 30 Then
		$sel_pntr = $sel_pntr - 30
		$win_opt = 3
	ElseIf $sel_pntr >= 20 Then
		$sel_pntr = $sel_pntr - 20
		$win_opt = 2
	ElseIf $sel_pntr >= 10 Then
		$sel_pntr = $sel_pntr - 10
		$win_opt = 1
	Else
		$win_opt = 0
		
	EndIf
	
	
	Local $winselect = GUICtrlRead($win_list)
	For $i = 0 To UBound($win_arlist) - 1
		If $winselect = ($win_arlist[$i][0] & "  --  " & $win_arlist[$i][1]) Then
			If WinExists($win_arlist[$i][1]) Then
				$win_client[$win_opt][$sel_pntr][0] = $win_arlist[$i][0]
				$win_client[$win_opt][$sel_pntr][1] = $win_arlist[$i][1]
				If $win_opt = 0 Then
					GUICtrlSetData($feed_wintitle[$sel_pntr], $win_arlist[$i][0] & @CRLF & $win_arlist[$i][1])
				ElseIf  $win_opt = 1 Then
					GUICtrlSetData($spam_wintitle[$sel_pntr], $win_arlist[$i][0] & @CRLF & $win_arlist[$i][1])
				ElseIf $win_opt = 2 Then
					GUICtrlSetData($buff_wintitle[$sel_pntr], $win_arlist[$i][0] & @CRLF & $win_arlist[$i][1])
				ElseIf $win_opt = 3 Then
					GUICtrlSetData($coll_wintitle[$sel_pntr], $win_arlist[$i][0] & @CRLF & $win_arlist[$i][1])
				EndIf
				
				
				
				GUISetState(@SW_ENABLE,$main)
				GUISetState(@SW_RESTORE,$main)
				GUIDelete($win_gui)
			Else
				_MsgBox(0,$title,"The selected client doesn't exist!" & @CRLF & "You should refresh the list.",$win_gui)
			EndIf
		EndIf		
	Next		
EndFunc


Func _MsgBox($flag,$title,$text,$gui)
	GUISetState(@SW_DISABLE,$gui)
	$msg = MsgBox($flag,$title,$text)
	GUISetState(@SW_ENABLE,$gui)
	GUISetState(@SW_RESTORE,$gui)
	Return $msg
EndFunc

Func _InputBox($title,$prompt,$default,$gui,$pass = "",$width = 0,$height = 0)
	GUISetState(@SW_DISABLE,$gui)
	$inpt = InputBox($title,$prompt,$default,$pass,$width,$height)
	GUISetState(@SW_ENABLE,$gui)
	GUISetState(@SW_RESTORE,$gui)
	Return $inpt
EndFunc





Func _Exit()
	_IniSave()
	Exit
EndFunc


Func _GUICtrlListBox_GetCurSel($hWnd)
	If IsHWnd($hWnd) Then
		Return _SendMessage($hWnd, 0x0188)
	Else
		Return GUICtrlSendMsg($hWnd, 0x0188, 0, 0)
	EndIf
EndFunc   ;==>_GUICtrlListBox_GetCurSel


Func _GUICtrlListBox_SetCurSel($hWnd, $iIndex)
	If IsHWnd($hWnd) Then
		Return _SendMessage($hWnd, 0x0186, $iIndex)
	Else
		Return GUICtrlSendMsg($hWnd, 0x0186, $iIndex, 0)
	EndIf
EndFunc   ;==>_GUICtrlListBox_SetCurSel

Func _SendMessage($hWnd, $iMsg, $wParam = 0, $lParam = 0, $iReturn = 0, $wParamType = "wparam", $lParamType = "lparam", $sReturnType = "lparam")
	Local $aResult = DllCall("user32.dll", $sReturnType, "SendMessage", "hwnd", $hWnd, "int", $iMsg, $wParamType, $wParam, $lParamType, $lParam)
	If @error Then Return SetError(@error, @extended, "")
	If $iReturn >= 0 And $iReturn <= 4 Then Return $aResult[$iReturn]
	Return $aResult
EndFunc 

Func _TicksToTime($iTicks, ByRef $iHours, ByRef $iMins, ByRef $iSecs)
	If Number($iTicks) > 0 Then
		$iTicks = Round($iTicks / 1000)
		$iHours = Int($iTicks / 3600)
		$iTicks = Mod($iTicks, 3600)
		$iMins = Int($iTicks / 60)
		$iSecs = Round(Mod($iTicks, 60))
		; If $iHours = 0 then $iHours = 24
		Return 1
	ElseIf Number($iTicks) = 0 Then
		$iHours = 0
		$iTicks = 0
		$iMins = 0
		$iSecs = 0
		Return 1
	Else
		SetError(1)
		Return 0
	EndIf
EndFunc

Func _ArrayDelete(ByRef $avArray, $iElement)
	If Not IsArray($avArray) Then Return SetError(1, 0, 0)

	Local $iUBound = UBound($avArray, 1) - 1

	If Not $iUBound Then
		$avArray = ""
		Return 0
	EndIf

	; Bounds checking
	If $iElement < 0 Then $iElement = 0
	If $iElement > $iUBound Then $iElement = $iUBound

	; Move items after $iElement up by 1
	Switch UBound($avArray, 0)
		Case 1
			For $i = $iElement To $iUBound - 1
				$avArray[$i] = $avArray[$i + 1]
			Next
			ReDim $avArray[$iUBound]
		Case 2
			Local $iSubMax = UBound($avArray, 2) - 1
			For $i = $iElement To $iUBound - 1
				For $j = 0 To $iSubMax
					$avArray[$i][$j] = $avArray[$i + 1][$j]
				Next
			Next
			ReDim $avArray[$iUBound][$iSubMax + 1]
		Case Else
			Return SetError(3, 0, 0)
	EndSwitch

	Return $iUBound
EndFunc   ;==>_ArrayDelete


Func _GUICtrlListBox_FindString($hWnd, $sText, $fExact = False)
	If IsHWnd($hWnd) Then
		If ($fExact) Then
			Return _SendMessage($hWnd, 0x01A2, -1, $sText, 0, "wparam", "str")
		Else
			Return _SendMessage($hWnd, 0x018F, -1, $sText, 0, "wparam", "str")
		EndIf
	Else
		If ($fExact) Then
			Return GUICtrlSendMsg($hWnd, 0x01A2, -1, $sText)
		Else
			Return GUICtrlSendMsg($hWnd, 0x018F, -1, $sText)
		EndIf
	EndIf
EndFunc   ;==>_GUICtrlListBox_FindString

Func _GUICtrlListBox_DeleteString($hWnd, $iIndex)
	If IsHWnd($hWnd) Then
		Return _SendMessage($hWnd,  0x0182, $iIndex)
	Else
		Return GUICtrlSendMsg($hWnd, 0x0182, $iIndex, 0)
	EndIf
EndFunc
